<template>
  <div class="button-list">
    <SlideButton 
      v-for="slide in filteredSlides" 
      :key="slide.id" 
      :title="slide.title" 
      :id="slide.id" 
      :is-animating="slide.isAnimating" 
      :time="slide.time || 5000"
      class="button"
      @done="buttonDoneHandler"
      @click.native="clickHandler(slide.id)"
    />
  </div>
</template>

<script>
import SlideButton from "./SlideButton";

export default {
  name: "SlidesButtons",
  components: {
    SlideButton
  },
  props: {
    activeId: {
      type: Number,
      required: true
    },
    slides: {
      type: Array,
      required: true
    }
  },
  computed: {
    filteredSlides() {
      return this.slides.map(cur => {
        return {
          title: cur.title,
          id: cur.id,
          time: cur.time,
          isAnimating: this.activeId === cur.id ? true : false
        }
      });
    }
  },
  methods: {
    buttonDoneHandler(id) {
      const nextId = (id + 1) % this.slides.length; 
      this.emitId(nextId);
    },
    clickHandler(id) {
      if (id === this.activeId) return;
      this.emitId(id);
    },
    emitId(id) {
      this.$emit("changeSlide", id);
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.button-list
  display grid
  direction rtl
  grid-template-columns repeat(4, minmax(15rem, 1fr))
  grid-gap $md
  @media only screen and (max-width 800px)
    grid-template-columns repeat(2, minmax(15rem, 1fr))
  @media only screen and (max-width 450px)
    grid-gap $sm
  @media only screen and (max-width 400px)
    grid-template-columns repeat(1, minmax(15rem, 1fr))
</style>